unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

// K
function factorial(x: int64): int64;
var
  j : integer;
begin
  result := 1;
  if (x = 0) or (x = 1) then exit;
  for j := 2 to  x do
    result := result * j;
end;

// 񍀌W
function binomial(n, k: integer): extended;
var
  nn, kn, knm: int64;
begin
  nn := factorial(n);
  kn := factorial(k);
  knm := factorial(n - k);
  result := nn / (kn * knm);
end;

// Bernoulli_number  vZ
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  N = 18;
var
  Bn: array of extended;
  i, k: integer;
  S, b, Bc: extended;
begin
  memo1.Clear;
  setlength(Bn, N + 1);
  Bn[0] := 1;
  memo1.Lines.Append('B' + intTostr(0) + '= ' + floatTostr(Bn[0]));
  for i := 1 to N do begin
    S := 0;
    for k := 0 to i -1 do begin
      b := binomial(i + 1, k);                // {(n + 1) / k}
      S := S + Bn[k] * b;                     // {(n + 1) / k} Bk    k=0 to n-1
    end;
    Bn[i] := S * (-1 / (i + 1));              // Bn = -1 / (n + 1) 
    Bc := Bn[i];
    if i > 2 then if i mod  2 <> 0 then Bc := 0;
    memo1.Lines.Append('B' + intTostr(i) + '= ' + floatTostr(Bc));
  end;
end;

// Bernoulli_number  ʍvZ
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  Bn : extended;
  S  : extended;
  n, m, j: integer;
  k  : integer;
begin
  k := 10;
  memo1.Clear;
  for n := 0 to K do begin
    Bn := 0;
    for j := 0 to n do begin
      S := 0;
      for m := j to n do
        S := S + 1 / (m + 1) * binomial(m, j);
      Bn := Bn + power(-1, J) * power(j, n) * S;
    end;
    memo1.Lines.Append('B' + intTostr(N) + '= ' + floatTostr(Bn));
  end;
end;

end.
